import { CosmosChainId } from '../../../..';
import { DirectSignResponse } from '@cosmjs/proto-signing';
import { Cosmos } from '@cosmostation/extension-client';
import { TxRaw } from '@routerprotocol/chain-api/cosmos/tx/v1beta1/tx_pb';
import { ConcreteCosmosWalletStrategy } from '../../types/strategy';
import { WalletDeviceType } from '../../../types/enums';
export default class Cosmostation implements ConcreteCosmosWalletStrategy {
    chainName: string;
    provider?: Cosmos;
    chainId: CosmosChainId;
    constructor(args: {
        chainId: CosmosChainId;
    });
    getWalletDeviceType(): Promise<WalletDeviceType>;
    isChainIdSupported(chainId?: CosmosChainId): Promise<boolean>;
    getAddresses(): Promise<string[]>;
    sendTransaction(transaction: DirectSignResponse | TxRaw): Promise<string>;
    signTransaction(transaction: {
        txRaw: TxRaw;
        accountNumber: number;
        chainId: string;
    }): Promise<DirectSignResponse>;
    getPubKey(): Promise<string>;
    private getProvider;
}
